//+------------------------------------------------------------------+
//|                                                       Ma RSI.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1 Lime
#property indicator_color2 Blue
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_color6 White
#property indicator_color7 White
#property indicator_color8 White
#property indicator_width8 3

#property indicator_minimum 0
#property indicator_maximum 100

#property indicator_level1 20
#property indicator_level2 80
#property indicator_level3 45
#property indicator_level4 55
#property indicator_level5 50

#property indicator_levelcolor Silver
//*************************************************************************

extern int TimeFrame = 0;
extern int aLine = 5;
extern int bLine = 14;
extern int aMethod = 1;
extern int bMethod = 1;
extern int minBar=300;
int bPrice = 0;

extern int       Length = 144;
extern int       Phase  = 55;

double dBuffer[];
double wBuffer[];
//double dMA[];
double rsi[];
//double dMA_[]
double UP[];
double DN[];
double up[];
double dn[];
double dot[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
   IndicatorDigits(5);
   
   SetIndexBuffer(0, dBuffer);
   SetIndexStyle(0, DRAW_LINE,STYLE_SOLID,2);

   SetIndexBuffer(1, rsi);
   SetIndexStyle(1, DRAW_LINE);
       
   SetIndexBuffer(2, wBuffer);
      
   SetIndexStyle(3,DRAW_ARROW,EMPTY);
   SetIndexArrow(3, 233);
   SetIndexLabel(3,"BUY");
   SetIndexDrawBegin(3,0);
   SetIndexBuffer(3,UP);
   
   SetIndexStyle(4,DRAW_ARROW,EMPTY);
   SetIndexArrow(4, 234);
   SetIndexLabel(4,"SELL");
   SetIndexDrawBegin(4,0);
   SetIndexBuffer(4,DN);
   
   SetIndexStyle(5,DRAW_ARROW,EMPTY);
   SetIndexArrow(5, 233);
   SetIndexLabel(5,"Buy");
   SetIndexDrawBegin(5,0);
   SetIndexBuffer(5,up);
   
   SetIndexStyle(6,DRAW_ARROW,EMPTY);
   SetIndexArrow(6, 234);
   SetIndexLabel(6,"Sell");
   SetIndexDrawBegin(6,0);
   SetIndexBuffer(6,dn);
   
   SetIndexStyle(7,DRAW_ARROW,EMPTY);
   SetIndexArrow(7, 119);
   SetIndexLabel(7,"Taskas");
   SetIndexDrawBegin(7,0);
   SetIndexBuffer(7,dot);
   
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("JMA_RSI  "+TimeFrameStr);
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   double dMA;
   int fd, fu,Fd, Fu;
      
   int counted_bars = IndicatorCounted();
   if(counted_bars < 0)       return(-1);

   if(counted_bars > 0)    counted_bars--;
   limit = Bars - counted_bars;
   for(int i = 0; i < limit; i++)
       wBuffer[i] = iMA(NULL, TimeFrame, aLine, 0, aMethod, bPrice, i);
       
   for(i = 0; i < limit; i++)
     {
       dBuffer[i] = iMA(NULL, TimeFrame, aLine, 0, aMethod, bPrice, i) + 
                    iMA(NULL, TimeFrame, aLine, 0, aMethod, bPrice, i) - 
                    (-iRSIOnArray(wBuffer, 0, bLine,  i));
       rsi[i]=iRSI(NULL, TimeFrame, 14, 0, i);       
     }
    for(i = 0; i < limit; i++)
     {
       double jma=iCustom(NULL,0,"JMA[i]",Length,Phase,0,i);
       
       if(dBuffer[i+1]>80 && dBuffer[i]<80)              //  
        {
            DN[i] = 70;                                     //kirto 80   --> 1
            Fd=-1;                                          // -1   
            Fu=0;                                           // 0
        }                                             
       
       if(dBuffer[i+1]<20 && dBuffer[i]>20)              //  
        {
            UP[i] = 30;                                     //kirto 20   --> 1
            Fu=1;                                           // 1
            Fd=0;                                           // 0
        }                                             
       
       if(dBuffer[i+1]>rsi[i+1] && dBuffer[i]<rsi[i])    //  
        {
            dn[i] = 60;                                     //susikirtimas pardavimui  -->  2 
            fd=-1;                                          // -1
            fu=0;                                           // 0
            Fu=0;
        }
       if(dBuffer[i+1]<rsi[i+1] && dBuffer[i]>rsi[i])    //  
        {
            up[i] = 40;                                     //susikirtimas pirkimui    -->  2
            fu=1;                                           // 1
            fd=0;                                           // 0
            Fd=0;
        }
        
 /*     
       90,  DN[i] = 70  dn[i] = 60.      80            .
       10,  DN[i] = 30  dn[i] = 40.      20            .
*/
       if(Fd==-1 && fd==-1 && jma>Close[i]) 
        {
            dot[i]=90; 
            Fd=0; 
            Fu=0; 
            fd=0; 
            fu=0;
        }
       if(Fu==1 && fu==1 && jma<Close[i])   
        {
            dot[i]=10; 
            Fd=0;   
            Fu=0; 
            fd=0; 
            fu=0;
        }
     }    
           
//----
   return(0);
  }
//+------------------------------------------------------------------+